package cz.zcu.kiv.db.dao;

import java.util.List;

import cz.zcu.kiv.db.model.osoby.Osoba;
import cz.zcu.kiv.db.model.studium.Obor;
import cz.zcu.kiv.db.model.studium.Predmet;
import cz.zcu.kiv.db.model.studium.PredmetVOboru;
import cz.zcu.kiv.db.model.studium.Program;
import cz.zcu.kiv.db.model.studium.VyukaPredmetu;

public interface StudiumDao {

    public List<Obor> getObory();
    
    public List<Obor> getObory(boolean vcetneNeaktivnich);

    public List<Predmet> getPredmety();
    
    public List<Predmet> getPredmety(boolean vcetneNeaktivnich);

    public List<Program> getProgramy();
    
    public List<Program> getProgramy(boolean vcetneNeaktivnich);

    public Obor getObor(int id);

    public Program getProgram(int id);

    public Predmet getPredmet(int id);

    public List<Obor> getOboryDleProgramu(Program program);
    
    public List<Obor> getOboryDleProgramu(Program program, boolean vcetneNeaktivnich);

    public void ulozObor(Obor obor);

    public void ulozPredmet(Predmet predmet);

    public void ulozProgram(Program program);

    public void smazObor(Obor obor);

    public void smazPredmet(Predmet predmet);

    public void smazProgram(Program program);

    public void deaktivujObor(Obor obor);

    public void deaktivujProgram(Program program);

    public void deaktivujPredmet(Predmet predmet);
    
    public List<VyukaPredmetu> getVyukaPredmetuDleOsoby(Osoba osoba);
    
    public List<VyukaPredmetu> getVyukaPredmetuDleOsoby(Osoba osoba, boolean vcetneNeaktivnich);
    
    public List<VyukaPredmetu> getVyukaPredmetuDlePredmetu(Predmet predmet);
    
    public List<VyukaPredmetu> getVyukaPredmetuDlePredmetu(Predmet predmet, boolean vcetneNeaktivnich);
        
    public List<PredmetVOboru> getPredmetVOboruDleOboru(Obor obor);
    
    public List<PredmetVOboru> getPredmetVOboruDleOboru(Obor obor, boolean vcetneNeaktivnich);
    
    public List<PredmetVOboru> getPredmetVOboruDlePredmetu(Predmet predmet);
    
    public List<PredmetVOboru> getPredmetVOboruDlePredmetu(Predmet predmet, boolean vcetneNeaktivnich);
    
    public void pridejVyucujicihoPredmetu(VyukaPredmetu vyuka);
    
    public void odeberVyucujicihoPredmetu(VyukaPredmetu vyuka);
    
    public void pridejPredmetDoOboru(PredmetVOboru predmetVOboru);
    
    public void odeberPredmetZOboru(PredmetVOboru predmetVOboru);
}

