package cz.zcu.kiv.db.dao;

import java.util.List;

import cz.zcu.kiv.db.model.osoby.Osoba;
import cz.zcu.kiv.db.model.studium.Obor;
import cz.zcu.kiv.db.model.studium.Tema;
import cz.zcu.kiv.db.model.studium.TypPrace;
import cz.zcu.kiv.db.model.studium.ZaverecnaPrace;

public interface TemaDao {

    public List<Tema> getTemata();

    public List<Tema> getTemata(boolean vcetneNeaktivnich);

    public List<TypPrace> getTypyPrace();

    public List<TypPrace> getTypyPrace(boolean vcetneNeaktivnich);

    public List<ZaverecnaPrace> getZaverecnePrace();

    public List<ZaverecnaPrace> getZaverecnePrace(boolean vcetneNeaktivnich);

    public Tema getTema(int id);

    public TypPrace getTypPrace(int id);

    public ZaverecnaPrace getZaverecnaPrace(int id);

    public void ulozTema(Tema tema);

    public void ulozTypPrace(TypPrace typ);

    public void ulozZaverecnouPraci(ZaverecnaPrace prace);

    public void smazTema(Tema tema);

    public void smazTypPrace(TypPrace typ);

    public void smazZaverecnouPrace(ZaverecnaPrace prace);

    public List<Tema> getTemataDleOsoby(Osoba osoba);

    public List<Tema> getTemataDleOsoby(Osoba osoba, boolean vcetneNeaktivnich);

    public List<Tema> getTemataDleOboru(Obor obor);

    public List<Tema> getTemataDleOboru(Obor obor, boolean vcetneNeaktivnich);

    public List<Tema> getTemataDleTypu(TypPrace typ);

    public List<Tema> getTemataDleTypu(TypPrace typ, boolean vcetneNeaktivnich);

    public void deaktivujTema(Tema tema);

    public void deaktivujTypPrace(TypPrace typ);

    public void deaktivujZaverecnouPraci(ZaverecnaPrace prace);
}
