package cz.zcu.kiv.db.dao.jdbc.model;

import java.util.List;

import cz.zcu.kiv.db.dao.StudiumDao;
import cz.zcu.kiv.db.dao.TemaDao;
import cz.zcu.kiv.db.model.studium.Obor;
import cz.zcu.kiv.db.model.studium.PredmetVOboru;
import cz.zcu.kiv.db.model.studium.Program;
import cz.zcu.kiv.db.model.studium.Tema;

/**
 *
 * @author Radek Muzika
 */
public class JdbcObor extends Obor {

    private int fkProgram;
    private StudiumDao _studiumDao;
    private TemaDao _temaDao;
    private boolean programNeni = false;

    @Override
    public List<PredmetVOboru> getPredmetyVOboru() {
        if (super.getPredmetyVOboru() == null) {
            this.setPredmetyVOboru(_studiumDao.getPredmetVOboruDleOboru(this));
        }
        return super.getPredmetyVOboru();
    }

    @Override 
    public Program getProgram() {
        if (super.getProgram() == null && !programNeni && fkProgram > 0) {
            super.setProgram(_studiumDao.getProgram(fkProgram));
            if (super.getProgram() == null) {
                programNeni = true;
            }
        }
        return super.getProgram();
    }

    @Override
    public List<Tema> getTemata() {
        if (super.getTemata() == null) {
            this.setTemata(_temaDao.getTemataDleOboru(this));
        }
        return super.getTemata();
    }

    public void setStudiumDao(StudiumDao studiumDao) {
        this._studiumDao = studiumDao;
    }

    public void setTemaDao(TemaDao temaDao) {
        this._temaDao = temaDao;
    }
}
