
package cz.zcu.kiv.db.dao.jdbc.model;

import cz.zcu.kiv.db.dao.OsobaDao;
import cz.zcu.kiv.db.model.osoby.Osoba;
import cz.zcu.kiv.db.model.udalosti.Udalost;

/**
 *
 * @author Radek Muzika
 */
public class JdbcUdalost extends Udalost{
    private int fkOsoba;
    private int fkKontaktniOsoba;
    
    private OsobaDao _osobaDao;

    private boolean odpovednaOsobaNeni = false;
    private boolean kontaktniOsobaNeni = false;
    
    @Override
    public Osoba getKontaktniOsoba() {
        if(super.getKontaktniOsoba()==null && !kontaktniOsobaNeni && fkKontaktniOsoba>0) {
            super.setKontaktniOsoba(_osobaDao.getOsoba(fkKontaktniOsoba));
            if(super.getKontaktniOsoba()==null) kontaktniOsobaNeni = true;
        }
        return super.getKontaktniOsoba();
    }

    @Override
    public Osoba getOdpovednaOsoba() {
        if(super.getOdpovednaOsoba()==null && !odpovednaOsobaNeni && fkOsoba>0) {
            super.setOdpovednaOsoba(_osobaDao.getOsoba(fkOsoba));
            if(super.getOdpovednaOsoba()==null) odpovednaOsobaNeni = true;
        }
        return super.getOdpovednaOsoba();
    }
    
    public int getFkOsoba() {
        return fkOsoba;
    }

    public void setFkOsoba(int fkOsoba) {
        this.fkOsoba = fkOsoba;
    }

    public int getFkKontaktniOsoba() {
        return fkKontaktniOsoba;
    }

    public void setFkKontaktniOsoba(int fkKontaktniOsoba) {
        this.fkKontaktniOsoba = fkKontaktniOsoba;
    }

    public void setOsobaDao(OsobaDao osobaDao) {
        this._osobaDao = osobaDao;
    }
}
